#!/usr/bin/perl -w 
use strict ;
use FileHandle ;
use Getopt::Long;
use Cwd ;
use MyUtils;
use ConfigPDB;
use MyGeom;

use Time::HiRes qw( usleep ualarm gettimeofday tv_interval clock_gettime clock_getres  clock);
use POSIX qw(floor);
my $commandline = util_get_cmdline("",\@ARGV) ;
my ($infile,$outfile,$which_tech,$listfile,$protein,$forcefield);
my (@expressions);
my $howmany = 100000 ;
GetOptions(
            "which_tech=s"=>\$which_tech ,
            "protein=s"=>\$protein ,
            "infile=s"=>\$infile ,
            "listfile=s"=>\$listfile ,
            "forcefield=s"=>\$forcefield ,
            "outfile=s"=>\$outfile ,
            "expr=s"=>\@expressions,
            "howmany=i"=>\$howmany ,
           );
die "Dont recognize command line arg @ARGV " if(@ARGV);
usage( "Need to give a output file name => option -outfile ") if(!defined $outfile);
my $ofh = util_write($outfile);
usage( "Need to give a protein pdb id -option -protein  ") if(!defined $protein);
usage( "Need to give a forcefield -option -forcefield  ") if(!defined $forcefield);
my $CNT = 0 ; 
my ($RESULTDIR,$PDBDIR,$FASTADIR,$APBSDIR,$FPOCKET,$SRC) = util_SetEnvVars();
my $PWD = cwd;
my ($PDB2PQR) = util_GetEnv("PDB2PQR");

my  ($seconds, $microseconds) = gettimeofday;

my $pdb = "$PDBDIR/$protein.pdb";

print "python $PDB2PQR/pdb2pqr.py  --whitespace --chain --apbs-input --ff=$forcefield $pdb $outfile = $forcefield\n";
my @l = `python $PDB2PQR/pdb2pqr.py --whitespace  --chain --apbs-input --ff=$forcefield $pdb $outfile`;
print @l , "\n";

print STDERR "Output written in $outfile\n";

my  $t0 = [gettimeofday];
my $elapsed = tv_interval ( $t0, [$seconds, $microseconds]);
print STDERR  "Elapsed time = $elapsed \n";

chmod 0777, $outfile ;
sub usage{
    my ($msg) = @_ ;
    print $msg , "\n" ; 
print << "ENDOFUSAGE" ; 
ENDOFUSAGE
    die ;
}
